【Golang】LeetCode 139. 单词拆分

139. 单词拆分

题目描述

思路

这是一道比较有意思的题目,非常能锻炼我们从 "动态规划" / "记忆化搜索" / "状态维护与转移" 的角度来进行程序设计的能力。

初次看到这道题目,我们很有可能会想到枚举法,通过暴力的枚举,以及开一个数组来判断当前位置及之前的子串能否通过wordDict当中给定的字符串来进行表示,从而解决这道题目。但正如方才所说的"暴力枚举",这种做法不够优雅,时间复杂度将会很高。

正确的做法其实是动态规划。具体来说,我们维护一个长度为len(s) + 1的 bool 数组dp,如果dp[i]为true,就代表i位置及其之前的子串可以对应到wordDict当中的某个字符串。我们通过双层循环来对dp数组进行维护。具体来说,第一层循环的变量为i,它对字符串s的每一个位置进行遍历;第二层循环的变量为j,它对wordDict当中的字符串进行遍历。如果i >= len(wordDict[j]),我们可以判断一次s[i - len(wordDict[j]): i]和wordDict[j]是否相等,如果相等,则判断dp[i - len(wordDict[j])]是否为true,这两个判断条件的含义是:我们首先判断当前s的子串是否可以匹配wordDict[j]字符串;如果能够匹配,就判断i - len(wordDict[j])位置之前的子串是否能匹配上wordDict当中的某个字符串,如果能匹配上,说明s[0: i - len(wordDict[j]]位置的子串也能通过wordDict当中的字符串表示,这就意味着到i位置为止,整个子串都可以通过wordDict当中的字符串表示,设置dp[i] = true。需要注意的是,应该设置dp[0]的初始值为true。

基于以上思路,我们可以编程来解决该问题。

Golang 题解

go 复制代码
func wordBreak(s string, wordDict []string) bool {
    n := len(s)
    dp := make([]bool, n + 1)
    dp[0] = true

    for i := 1; i <= n; i ++ {
        for j := 0; j < len(wordDict); j ++ {
            if i >= len(wordDict[j]) && s[i - len(wordDict[j]): i] == wordDict[j] && dp[i - len(wordDict[j])] {
                dp[i] = true
            }
        }
    }

    return dp[n]
}
相关推荐
zyl76517 小时前
FlashAttention 详解:从 GPU 硬件、普通 Attention 到分块计算与 Online Softmax
算法
爱读书的小胖20 小时前
LeetCode 122:买卖股票的最佳时机 II(C)解题分析
算法
结局无敌20 小时前
React Native for OpenHarmony 实战:三方库 react-native-modal-dialog 的鸿蒙化适配指南
深度学习·算法·react native·react.js·harmonyos
OPEN-F21 小时前
ROS2系列教程:上位机建图与导航(原理综合)
算法·机器人
weixin_3077791321 小时前
C++代码实现MATLAB中的fitrtree函数功能
开发语言·c++·算法·matlab
tomwang032221 小时前
路径优化建模、优化算法分类及工程化小结
算法·数学建模·分类
小羊没烦恼!21 小时前
Ajax与JSON的一些总结
android·java·前端·数据库·mysql·算法·okhttp
2501_9269783321 小时前
人机通信协议--人和机器之间的交互想象
人工智能·经验分享·算法·ai写作
行者全栈架构师1 天前
【鸿蒙心迹】互动卡片全链路——把核心功能放到桌面(FormKit 实战)(HarmonyOS 7.x)
前端·算法·架构
无定义_1 天前
10.11日常训练
算法